#-*-coding:utf-8-*-

import pygtk
import gtk
import gobject

from gtk import glade
from posh.backend import db_mapper

class Profile:
    def __init__(self, gladefile):
        self.widgets = glade.XML(gladefile)
        self.profilelist = self.widgets.get_widget('profilelist')
        self.profilethumbslist = self.widgets.get_widget('profilethumbslist')
        self.thumbslist = self.widgets.get_widget('thumbslist')

        self.init_profilelist()
        self.fill_profilelist()

        self.init_thumbslist()
        self.fill_thumbslist()

    def init_profilelist(self):
        """
            initialise la liste de profiles
        """
        model = gtk.ListStore(gobject.TYPE_STRING)
        self.profilelist.set_model(model)

    def fill_profilelist(self):
        """ remplie la select box avec les onglets
        """
        profiles = db_mapper.get_profiles()
        model = self.profilelist.get_model()
        model.clear()
        for profile in profiles:
            model.append([profile['name']])
        self.profilelist.set_active(0)

    def init_thumbslist(self):
        """
            initialise la liste d'onglet
        """
        # Création des colonnes
        model = gtk.TreeStore(gobject.TYPE_INT, gobject.TYPE_STRING, gobject.TYPE_STRING)
        renderer = gtk.CellRendererText()
        column = gtk.TreeViewColumn("Noms de l'onglet", renderer, text=1)
        self.thumbslist.append_column(column)
        column = gtk.TreeViewColumn('Url', renderer, text=2)
        self.thumbslist.append_column(column)
        self.thumbslist.set_model(model)
        self.thumbslist.set_headers_visible(True)
        self.thumbslist.get_selection().set_mode(gtk.SELECTION_MULTIPLE)

    def fill_thumbslist(self):
        """ remplissage de la liste des onglets disponibles """
        thumbs = db_mapper.get_thumbs()
        model = self.thumbslist.get_model()
        model.clear()
        for thumb in thumbs:
            mod_iter = model.insert_before(None, None)
            model.set_value(mod_iter, 1, thumb['thumbid'])
            model.set_value(mod_iter, 1, thumb['name'])
            model.set_value(mod_iter, 2, thumb['url'])


def main():
    gladefile = './interface/interface.glade'
    epack = Profile(gladefile)
    gtk.main()

if __name__ == "__main__":
    main()

